
class Brw{
   
   pageJsonGrid; 
   pageJsonForm;

   constructor( pageJsonGrid , pageJsonForm ){     
     
     $("#page").text( 1 );
	 this.pageJsonGrid = pageJsonGrid;
	 this.pageJsonForm = pageJsonForm;
     this.refreshGrid(); // Leitura inicial
	 this.buttonUpdate();

   }

   refreshGrid( nSkip = 0 ){
      
	  var auxPageJsonGrid = this.pageJsonGrid;	
	  
      $("#anterior").attr("disabled", true );

      $("#page").text( parseInt( $("#page").text() )  + nSkip);     
	  $("#registros thead").empty();    
      $("#registros tbody").empty();   
	  
      $.ajax({ 
              type: 'GET',
              url: auxPageJsonGrid,
              data: {
                     pagina: $("#page").text()
               },
              async: false,        
              dataType: 'json',
              success: function( data ){
				    let head = "";
					let row;
					let ord;
				  
                    $("#anterior").attr("disabled", !data.PreviousPage );
                    $("#proximo").attr("disabled", !data.NextPage );
					switch ( data.Result ){
                     case 'OK':   

					    head += '<tr>';
						for ( let elem of data.Header ){
							head += '<th>' + elem + '</th>';
					    }
						head += '</tr>';
						$( head ).appendTo("#registros thead");

                        for ( let val of data.Rows ){
							if ( typeof val.___pk != "undefined" )
								row = '<tr ___pk=' + val.___pk + '>';
							else
								row = '<tr>';
							ord = -1

							for ( let elem in val ){
								if (elem != "___pk")
									row += '<td width="'+ data.Width[++ord] +'">' + val[elem] + '</td>';
							}
							row += "</tr>";

							$( row ).appendTo("#registros tbody");
						}	
						
                        
                        break;
                  }   
              }  
      }); // ajax
  }


  nextPage(){
     this.refreshGrid( +1 );
	 this.buttonUpdate();
  }

  previousPage(){
     this.refreshGrid( -1 );
	 this.buttonUpdate();
  }

  buttonUpdate(){
	let attr = $("#registros tbody tr").attr('___pk');  
    if (typeof attr !== typeof undefined && attr !== false) { // Se tem o atributo ___pk na linha
	   // Crio a coluna extra e dentro dele coloco um botão (vai ficar um botão por linha)
		 $("#registros tbody tr").each(function() {
			$(this).append('<td><button type="button" class="btn btn-primary btn-sm" data-toggle="modal" data-target="#formModal">Alterar</button></td>');
		 });
	   // Crio eventos para cada botão criado
	     var auxPageJsonForm = this.pageJsonForm;	
		 $("#registros tbody tr td button").click(function() {
			  var auxPkValue = $(this).closest("tr").attr('___pk'); // Mando a chave
			  $.ajax({ 
					  type: 'POST',
					  url: auxPageJsonForm,
					  data: {
							 ___pk: auxPkValue
					   },
					  async: false,        
					  dataType: 'json',
					  success: function( data ){
								$( "#formModal" ).find( "#___pk" ).val( auxPkValue ); 
								for ( let elem in data )
									$( "#formModal" ).find( "#" + elem ).val( data[elem] ); 

					  }  
			  }); // ajax
		 });
	}
  }
  
}
