﻿#define adOpenForwardOnly 0
#define adOpenKeyset 1
#define adOpenDynamic 2
#define adOpenStatic 3
#define adLockReadOnly 1
#define adLockPessimistic 2
#define adLockOptimistic 3
#define adLockBatchOptimistic 4
#define adUseNone 1
#define adUseServer 2
#define adUseClient 3
#define adStateClose 

#xtranslate TEXT SQL TO <v>  => #pragma __text|<v>+=%s;<v>:="" 

function main

   LOCAL oRs , oCn, cSql, cSQLReturn, cSQLNext, lNextPage := .t. , lPreviousPage := .t.
   LOCAL cString := "Driver={Microsoft Access Driver (*.mdb, *.accdb)};DBQ=" + PathBase() + "/scott.mdb"
   LOCAL hReg 
   LOCAL aReg := {}, aHead := {}, aWidth := {}
   LOCAL hGet := AP_GetPairs()
   LOCAL nPagina := VAL( hb_HGetDef( hGet , "pagina" , "1" )) // Se não informar a página recebe 1 (primeira página) 
   LOCAL nRegistroPorPagina := 3
   

   oCn := win_oleCreateObject( "ADODB.Connection" ) 
   oCn:ConnectionString := cString
   oCn:Open()
   
   oRs := win_oleCreateObject( "ADODB.Recordset" ) 
   oRs:CursorLocation = adUseClient
   
   
   TEXT SQL TO cSQL
      
        SELECT TOP :registroPorPagina tb01.*
            FROM emp AS tb01
            LEFT JOIN (
                SELECT TOP :offset empno FROM emp ORDER BY empno ASC
            ) AS tb02
            ON tb01.empno = tb02.empno
        WHERE ISNULL(tb02.empno)
        ORDER BY tb01.empno ASC
   
   ENDTEXT
   
   cSQLReturn := StrTran( cSQL , ":registroPorPagina" , hb_ntos( nRegistroPorPagina ) )
   cSQLReturn := StrTran( cSQLReturn , ":offset" , hb_ntos( nRegistroPorPagina * ( nPagina  )  ) ) 
   
  
   oRs:Open( cSQLReturn , oCn , adOpenDynamic, adLockOptimistic )

   if oRs:recordcount > 0
        oRs:Movefirst()
        do while !oRs:eof()
            hReg := {=>}
            hReg[ "___pk" ] := oRs:fields("empno"):value 
            hReg[ "ename" ] := oRs:fields("ename"):value 
            hReg[ "job" ] := oRs:fields("job"):value 
            AADD( aReg , hReg )
            oRs:movenext()
        enddo
        oRs:Movefirst() // Opcional, retorna para o primeiro registro
    endif    
    oRs:Close()
    
    // Head
    
    AADD( aHead , "Nome" );AADD( aWidth , "60%" )
    AADD( aHead , "Cargo" );AADD( aWidth , "40%" )
    IF LEN( aReg ) > 0
       IF hb_HHasKey( aReg[1] , "___pk" )
           AADD( aHead , "" )
       ENDIF
    ENDIF   
    

   // A próxima página existe ?

   cSQLNext := StrTran( cSQL , ":registroPorPagina" , hb_ntos( nRegistroPorPagina ) )
   cSQLNext := StrTran( cSQLNext , ":offset" , hb_ntos( nRegistroPorPagina * ( nPagina+1  )  ) ) 
   oRs:Open( cSQLNext , oCn , adOpenDynamic, adLockOptimistic )
   if oRs:recordcount == 0
       lNextPage := .f.
    endif   
   // A página anterior existe ?
   if nPagina-1 <= 0
       lPreviousPage := .f.
    endif
    
    
    ?? hb_JsonEncode( { "Result" => "OK" , "NextPage" => lNextPage , "PreviousPage" => lPreviousPage , "Header" => aHead , "Width" => aWidth , "Rows" => aReg } )

return nil

/**
https://stackoverflow.com/questions/8627032/ms-access-limit-x-y
https://php.developreference.com/article/25294673/MS+Access+LIMIT+X%2C+Y

SELECT TOP PageItemsCount tb01.*
FROM myTable AS tb01
LEFT JOIN (
SELECT TOP OffsetValue ID FROM myTable ORDER BY ID ASC
) AS tb02
ON tb01.ID = tb02.ID
WHERE ISNULL(tb02.ID)
ORDER BY tb01.ID ASC


SELECT Person.*
FROM Person
WHERE Person.Id In 
      (
        SELECT TOP 10 A.Id
        FROM [
               SELECT TOP 30 Person.Name, Person.Id
               FROM Person
               ORDER BY Person.Name, Person.Id
             ]. AS A
        ORDER BY A.Name DESC, A.Id DESC
      )
ORDER BY Person.Name, Person.Id;
*/